apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ artifactory_name }}-slave
  name: {{ artifactory_name }}-slave
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ (artifactory_replicas | int) - 1 }}
  selector:
    matchLabels:
      name: {{ artifactory_name }}-slave
  template:
    metadata:
      labels:
        name: {{ artifactory_name }}-slave
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values:
                - {{ artifactory_name }}
                - {{ artifactory_name }}-slave
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values:
                  - {{ artifactory_name }}
                  - {{ artifactory_name }}-slave
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DB_TYPE
{% if artifactory_db_type == 'postgres' %}
          value: postgresql
        - name: DB_HOST
          value: {{ artifactory_pg_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ artifactory_pg_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ artifactory_pg_name }}
        - name: DB_PORT
          value: "5432"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ artifactory_pg_name }}
{% elif artifactory_db_type in [ 'percona' ] %}
          value: mariadb
        - name: DB_HOST
          value: {{ artifactory_pc_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ artifactory_pc_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ artifactory_pc_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ artifactory_pc_name }}
{% elif artifactory_db_type in [ 'mariadb', 'mysql' ] %}
          value: mariadb
        - name: DB_HOST
          value: {{ artifactory_ms_name }}
        - name: DB_NAME
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ artifactory_ms_name }}
        - name: DB_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ artifactory_ms_name }}
        - name: DB_PORT
          value: "3306"
        - name: DB_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ artifactory_ms_name }}
{% endif %}
        - name: ARTIFACTORY_MASTER_KEY
          valueFrom:
            secretKeyRef:
              name: {{ artifactory_name }}
              key: master.key
        - name: HA_NODE_ID
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: HA_IS_PRIMARY
          value: "false"
        - name: ART_PRIMARY_BASE_URL
          value: "http://{{ artifactory_name }}.{{ namespace }}.svc.{{ cluster_domain }}:8081/artifactory"
        - name: HA_MEMBERSHIP_PORT
          value: "10042"
        - name: EXTRA_JAVA_OPTIONS
          value: "{{ artifactory_java_options | join(' ') }}"
        image: {{ (opsimages | json_query("[?name=='artifactory'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /artifactory/webapp/#/login
            port: 8081
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 10
        name: artifactory
        ports:
        - containerPort: 8081
        - containerPort: 10042
        readinessProbe:
          httpGet:
            path: /artifactory/webapp/#/login
            port: 8081
          initialDelaySeconds: 30
          timeoutSeconds: 10
        resources:
          requests:
            cpu: "{{ artifactory_cpu_request }}"
            memory: "{{ artifactory_memory_request }}"
          limits:
            cpu: "{{ artifactory_cpu_limit }}"
            memory: "{{ artifactory_memory_limit }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8081
{% endif %}
        volumeMounts:
        - mountPath: /var/opt/jfrog/artifactory
          name: data
          subPath: artifactory
      initContainers:
      - command:
        - sh
        - -c
        - rm -rf /var/opt/jfrog/artifactory/data/.lock
        image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
        name: remove-data-lock
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/opt/jfrog/artifactory
          name: data
          subPath: artifactory
{% if artifactory_db_type == 'postgres' %}
        - mountPath: /opt/jfrog/artifactory/misc/db/postgresql.properties
          name: secrets
          subPath: postgresql.properties
{% elif artifactory_db_type in [ 'mariadb', 'mysql' ] %}
        - mountPath: /opt/jfrog/artifactory/misc/db/mariadb.properties
          name: secrets
          subPath: mariadb.properties
{% endif %}
      - command:
        - sh
        - -c
        - "until nc -z -w 2 {{ artifactory_pg_name }} 5432 && echo database ok; do sleep 2; done"
        image: {{ (opsimages | json_query("[?name=='alpine'].image"))[0] }}
        name: wait-for-db
        securityContext:
          allowPrivilegeEscalation: false
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ artifactory_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ artifactory_name }}-slave
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: secrets
        secret:
          secretName: {{ artifactory_name }}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ artifactory_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
